
package org.mule.modules.workday.hr.config.spring;

import java.util.List;
import org.apache.commons.lang.StringUtils;
import org.mule.config.spring.MuleHierarchicalBeanDefinitionParserDelegate;
import org.mule.config.spring.util.SpringXMLUtils;
import org.mule.modules.workday.hr.config.UpdateEmployeePersonalInfoMessageProcessor;
import org.mule.util.TemplateParser;
import org.springframework.beans.MutablePropertyValues;
import org.springframework.beans.PropertyValue;
import org.springframework.beans.factory.config.BeanDefinition;
import org.springframework.beans.factory.config.RuntimeBeanReference;
import org.springframework.beans.factory.support.BeanDefinitionBuilder;
import org.springframework.beans.factory.support.ManagedList;
import org.springframework.beans.factory.support.ManagedMap;
import org.springframework.beans.factory.xml.BeanDefinitionParser;
import org.springframework.beans.factory.xml.ParserContext;
import org.springframework.util.xml.DomUtils;
import org.w3c.dom.Element;

public class UpdateEmployeePersonalInfoDefinitionParser
    implements BeanDefinitionParser
{

    /**
     * Mule Pattern Info
     * 
     */
    private TemplateParser.PatternInfo patternInfo;

    public UpdateEmployeePersonalInfoDefinitionParser() {
        patternInfo = TemplateParser.createMuleStyleParser().getStyle();
    }

    public BeanDefinition parse(Element element, ParserContext parserContent) {
        BeanDefinitionBuilder builder = BeanDefinitionBuilder.rootBeanDefinition(UpdateEmployeePersonalInfoMessageProcessor.class.getName());
        String configRef = element.getAttribute("config-ref");
        if ((configRef!= null)&&(!StringUtils.isBlank(configRef))) {
            builder.addPropertyValue("moduleObject", configRef);
        }
        Element employeePersonalInfoDataListElement = null;
        employeePersonalInfoDataListElement = DomUtils.getChildElementByTagName(element, "employee-personal-info-data");
        List<Element> employeePersonalInfoDataListChilds = null;
        if (employeePersonalInfoDataListElement!= null) {
            String employeePersonalInfoDataRef = employeePersonalInfoDataListElement.getAttribute("ref");
            if ((employeePersonalInfoDataRef!= null)&&(!StringUtils.isBlank(employeePersonalInfoDataRef))) {
                if ((!employeePersonalInfoDataRef.startsWith(patternInfo.getPrefix()))&&(!employeePersonalInfoDataRef.endsWith(patternInfo.getSuffix()))) {
                    builder.addPropertyValue("employeePersonalInfoData", new RuntimeBeanReference(employeePersonalInfoDataRef));
                } else {
                    builder.addPropertyValue("employeePersonalInfoData", employeePersonalInfoDataRef);
                }
            } else {
                ManagedMap employeePersonalInfoData = new ManagedMap();
                employeePersonalInfoDataListChilds = DomUtils.getChildElementsByTagName(employeePersonalInfoDataListElement, "employee-personal-info-datum");
                if (employeePersonalInfoDataListChilds!= null) {
                    if (employeePersonalInfoDataListChilds.size() == 0) {
                        employeePersonalInfoDataListChilds = DomUtils.getChildElements(employeePersonalInfoDataListElement);
                    }
                    for (Element employeePersonalInfoDataChild: employeePersonalInfoDataListChilds) {
                        String employeePersonalInfoDataValueRef = employeePersonalInfoDataChild.getAttribute("value-ref");
                        String employeePersonalInfoDataKeyRef = employeePersonalInfoDataChild.getAttribute("key-ref");
                        Object valueObject = null;
                        Object keyObject = null;
                        if ((employeePersonalInfoDataValueRef!= null)&&(!StringUtils.isBlank(employeePersonalInfoDataValueRef))) {
                            valueObject = new RuntimeBeanReference(employeePersonalInfoDataValueRef);
                        } else {
                            valueObject = employeePersonalInfoDataChild.getTextContent();
                        }
                        if ((employeePersonalInfoDataKeyRef!= null)&&(!StringUtils.isBlank(employeePersonalInfoDataKeyRef))) {
                            keyObject = new RuntimeBeanReference(employeePersonalInfoDataKeyRef);
                        } else {
                            keyObject = employeePersonalInfoDataChild.getAttribute("key");
                        }
                        if ((keyObject == null)||((keyObject instanceof String)&&StringUtils.isBlank(((String) keyObject)))) {
                            keyObject = employeePersonalInfoDataChild.getTagName();
                        }
                        employeePersonalInfoData.put(keyObject, valueObject);
                    }
                }
                builder.addPropertyValue("employeePersonalInfoData", employeePersonalInfoData);
            }
        }
        Element employeeReferenceListElement = null;
        employeeReferenceListElement = DomUtils.getChildElementByTagName(element, "employee-reference");
        List<Element> employeeReferenceListChilds = null;
        if (employeeReferenceListElement!= null) {
            String employeeReferenceRef = employeeReferenceListElement.getAttribute("ref");
            if ((employeeReferenceRef!= null)&&(!StringUtils.isBlank(employeeReferenceRef))) {
                if ((!employeeReferenceRef.startsWith(patternInfo.getPrefix()))&&(!employeeReferenceRef.endsWith(patternInfo.getSuffix()))) {
                    builder.addPropertyValue("employeeReference", new RuntimeBeanReference(employeeReferenceRef));
                } else {
                    builder.addPropertyValue("employeeReference", employeeReferenceRef);
                }
            } else {
                ManagedMap employeeReference = new ManagedMap();
                employeeReferenceListChilds = DomUtils.getChildElementsByTagName(employeeReferenceListElement, "employee-reference");
                if (employeeReferenceListChilds!= null) {
                    if (employeeReferenceListChilds.size() == 0) {
                        employeeReferenceListChilds = DomUtils.getChildElements(employeeReferenceListElement);
                    }
                    for (Element employeeReferenceChild: employeeReferenceListChilds) {
                        String employeeReferenceValueRef = employeeReferenceChild.getAttribute("value-ref");
                        String employeeReferenceKeyRef = employeeReferenceChild.getAttribute("key-ref");
                        Object valueObject = null;
                        Object keyObject = null;
                        if ((employeeReferenceValueRef!= null)&&(!StringUtils.isBlank(employeeReferenceValueRef))) {
                            valueObject = new RuntimeBeanReference(employeeReferenceValueRef);
                        } else {
                            valueObject = employeeReferenceChild.getTextContent();
                        }
                        if ((employeeReferenceKeyRef!= null)&&(!StringUtils.isBlank(employeeReferenceKeyRef))) {
                            keyObject = new RuntimeBeanReference(employeeReferenceKeyRef);
                        } else {
                            keyObject = employeeReferenceChild.getAttribute("key");
                        }
                        if ((keyObject == null)||((keyObject instanceof String)&&StringUtils.isBlank(((String) keyObject)))) {
                            keyObject = employeeReferenceChild.getTagName();
                        }
                        employeeReference.put(keyObject, valueObject);
                    }
                }
                builder.addPropertyValue("employeeReference", employeeReference);
            }
        }
        BeanDefinition definition = builder.getBeanDefinition();
        definition.setAttribute(MuleHierarchicalBeanDefinitionParserDelegate.MULE_NO_RECURSE, Boolean.TRUE);
        MutablePropertyValues propertyValues = parserContent.getContainingBeanDefinition().getPropertyValues();
        if (parserContent.getContainingBeanDefinition().getBeanClassName().equals("org.mule.config.spring.factories.PollingMessageSourceFactoryBean")) {
            propertyValues.addPropertyValue("messageProcessor", definition);
        } else {
            if (parserContent.getContainingBeanDefinition().getBeanClassName().equals("org.mule.enricher.MessageEnricher")) {
                propertyValues.addPropertyValue("enrichmentMessageProcessor", definition);
            } else {
                PropertyValue messageProcessors = propertyValues.getPropertyValue("messageProcessors");
                if ((messageProcessors == null)||(messageProcessors.getValue() == null)) {
                    propertyValues.addPropertyValue("messageProcessors", new ManagedList());
                }
                List listMessageProcessors = ((List) propertyValues.getPropertyValue("messageProcessors").getValue());
                listMessageProcessors.add(definition);
            }
        }
        return definition;
    }

    protected String getAttributeValue(Element element, String attributeName) {
        if (!StringUtils.isEmpty(element.getAttribute(attributeName))) {
            return element.getAttribute(attributeName);
        }
        return null;
    }

    private String generateChildBeanName(Element element) {
        String id = SpringXMLUtils.getNameOrId(element);
        if (StringUtils.isBlank(id)) {
            String parentId = SpringXMLUtils.getNameOrId(((Element) element.getParentNode()));
            return ((("."+ parentId)+":")+ element.getLocalName());
        } else {
            return id;
        }
    }

}
